/*
 * @Author: Wangtao
 * @Date: 2023-09-22 18:41:02
 * @LastEditors: Wangtao
 * @LastEditTime: 2024-02-04 17:35:34
 */

window.ueSimpleSoftphone = {
  initState: false,
  isInit: false,
  isInitApp: false,
  initParams: {},
  init: function (options) {
    if (!options.accountId && !options.accountName) {
      console.error('accountId or accountName is null')
      return
    }
    if (!options.agentNumber && !options.accountName) {
      console.error('agentNumber or accountName is null')
      return
    }
    if (!options.password) {
      console.error('password is null')
      return
    }
    if (!options.loginType) {
      console.error('loginType is null')
      return
    }
    window.ueSimpleSoftphone.initParams.accountId = options.accountId
    window.ueSimpleSoftphone.initParams.agentNumber = options.agentNumber
    window.ueSimpleSoftphone.initParams.accountName = options.accountName
    window.ueSimpleSoftphone.initParams.password = options.password
    window.ueSimpleSoftphone.initParams.loginType = options.loginType
    window.ueSimpleSoftphone.initParams.server = options.server || ''
    window.ueSimpleSoftphone.initParams.isOpenCallQueue = options.isOpenCallQueue || false
    window.ueSimpleSoftphone.initParams.isOpenNetwork = options.isOpenNetwork || false
    window.ueSimpleSoftphone.initParams.openNlsTranslation = options.openNlsTranslation || false
    window.ueSimpleSoftphone.isInit = true
    // 电话条是否可以移动及初始化位置
    if (options.phoneMoveMsg) {
      window.ueSimpleSoftphone.initParams.phoneMoveMsg = options.phoneMoveMsg
    }
    // 呼叫队列盒子是否可以移动及初始化位置
    if (options.quickBarMoveMsg) {
      window.ueSimpleSoftphone.initParams.quickBarMoveMsg = options.quickBarMoveMsg
    }
    // 网络盒子是否可以移动及初始化位置
    if (options.networkMoveMsg) {
      window.ueSimpleSoftphone.initParams.networkMoveMsg = options.networkMoveMsg
    }
    // 实时转译盒子是否可以移动及初始化位置
    if (options.nlsMoveMsg) {
      window.ueSimpleSoftphone.initParams.nlsMoveMsg = options.nlsMoveMsg
    }
    // 初始化成功失败事件
    if (options.success && typeof options.success === 'function') {
      window.ueSimpleSoftphone.success = options.success
    }
    if (options.error && typeof options.error === 'function') {
      window.ueSimpleSoftphone.error = options.error
    }
    //通话事件
    if (options.listenCallEvent && typeof options.listenCallEvent === 'function') {
      window.ueSimpleSoftphone.backEventFunction = options.listenCallEvent
    }
    //呼叫队列
    if (options.isOpenCallQueue && typeof options.listenCallQueueEvent === 'function') {
      window.ueSimpleSoftphone.listenCallQueueEvent = options.listenCallQueueEvent
    }
    //网络检测事件
    if (options.isOpenNetwork && options.listenCallNetork && typeof options.listenCallNetork === 'function') {
      window.ueSimpleSoftphone.listenCallNetork = options.listenCallNetork
    }
    if (window.ueSimpleSoftphone.initState && !window.ueSimpleSoftphone.isInitApp) {
      window.ueSimpleSoftphone.initApp()
    }
  },
  initApp: function () {
    Vue.createApp({
      components: {
        demo: myLib
      }
    }).mount('#ue-app')
    window.ueSimpleSoftphone.isInitApp = true
  }
}
function loadModule(url) {
  return new Promise(function (resolve, reject) {
    var script = document.createElement('script')
    script.src = url

    script.onload = function () {
      resolve()
    }

    script.onerror = function () {
      reject()
    }

    document.head.appendChild(script)
  })
}

function getAudio(id) {
  var el = document.getElementById(id)
  if (!(el instanceof HTMLAudioElement)) {
    // 没有音频dom,重新创建一个
    // throw new Error(`Element '${id}' not found or not an audio element.`)
    var audio = new Audio()
    audio.controls = true
    audio.autoplay = true
    audio.id = 'm7remoteAudio'
    audio.style.display = 'none'
    document.body.appendChild(audio)
    return document.getElementById(id)
  } else {
    return el
  }
}

const nowDate = new Date().getTime()
console.log(nowDate, 'nowDate')
// loadModule(`./ue-global.js?time=${nowDate}`).then(() => {
loadModule('https://cdn.jsdelivr.net/npm/ue-softphone-sdk-vue@0.0.24/ue-global.js').then(() => {
  window.onload = function () {
    document.body.insertAdjacentHTML(
      'beforeend',
      `<div id="ue-app">
        <demo></demo>
      </div>`
    )
    var audioElement = getAudio('m7remoteAudio')
    // var script = document.createElement('script');
    // script.src = 'https://unpkg.com/vue@3.3.4/dist/vue.global.js'; // 替换为要执行的 JavaScript 文件的 URL
    // document.head.appendChild(script);
    // softphone.useasy.cn
    // 测试1 softphone.useasy.cn
    loadModule('https://cdn.jsdelivr.net/npm/ue-softphone-sdk-vue@0.0.24/dist/myLib.umd.min.js').then(() => {
      fetch('https://cdn.jsdelivr.net/npm/ue-softphone-sdk-vue@0.0.24/dist/myLib.css')
        // loadModule(`./dist/myLib.umd.min.js?time=${nowDate}`).then(() => {
        //   fetch(`./dist/myLib.css?time=${nowDate}`)
        .then((response) => response.text())
        .then((content) => {
          var style = document.createElement('style')
          style.type = 'text/css'
          style.innerHTML = content
          document.getElementsByTagName('head')[0].appendChild(style)
          window.ueSimpleSoftphone.initState = true
          if (window.ueSimpleSoftphone.isInit && !window.ueSimpleSoftphone.isInitApp) {
            window.ueSimpleSoftphone.initApp()
          }
        })
    })
  }
})
